#pragma once

#include "NPCommonUI.h"
#include "Component.h"
#include "Container.h"
#include "Object.h"

#define TIXML_USE_STL
#include "tinyxml.h"

/**
* @ingroup 		
* @brief 	
* @date		08/06/2007
* @author	telltale
* @remark	
*/
interface NPCOMMONUI_API IScriptletComponentPlugin : public Object
{
public:
	virtual ~IScriptletComponentPlugin() 
	{
		/*static int count = 0;
		count++;
		ATLTRACE(_T("~IScriptletComponentPlugin count(%d)\n"), count);*/
	}
	/**
	* @brief 	{kr} ־ XML ؼϿ Component Ѵ. {/kr}
	*/
	virtual BOOL PreModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode) = 0;
	virtual BOOL ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode) = 0;
	virtual BOOL PostModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode) = 0;
	/**
	* @brief 	{kr} ־ XML ؼϿ Component ϰ Ѵ. {/kr}
	*/
	virtual CComponent* CreateComponent(CContainer* pParent, TiXmlElement* pNode) = 0;
};